/*! For license information please see plan-repository.js.LICENSE.txt */
"use strict";import FuzzyMatcher from"./fuzzy-matcher.js";import ENV from"../env.js";import Log from"../lib/log.js";import T from"../lib/tool.js";import Config from"../lib/config.js";import Storage from"../lib/storage.js";const state={globalPlan:null,cachedPlans:[],customPlans:null,publicPlanPointers:[],publicPlanDict:{}};function initPublicPlanPointers(){Storage.get("assistant.public-plan.pointers").then((t=>{t&&(state.publicPlanPointers=t)}))}async function get(t){const a=await getDefaultTagStatus();return{globalPlan:await getGlobalPlan(),pagePlan:await getPagePlan(t),defaultTagStatus:a}}const DEFAULT_GLOBAL_PLAN={name:"the global plan",disabled:!0};async function getDefaultTagStatus(){return await Storage.get("assistant.default-tag-status","")}async function getGlobalPlan(){return state.globalPlan||(state.globalPlan=await Storage.get("assistant.global-plan",DEFAULT_GLOBAL_PLAN)),state.globalPlan}async function getPagePlan(t){const a=a=>T.any(T.toArray(a.pattern),(a=>FuzzyMatcher.matchUrl(t,a)))&&!T.any(T.toArray(a.excludePattern),(a=>FuzzyMatcher.matchUrl(t,a))),e=state.cachedPlans.find(a);if(e)return e;null===state.customPlans&&(state.customPlans=await Storage.get("assistant.custom-plans",[]));const s=state.customPlans.find(a);if(s)return state.cachedPlans.unshift(s),s;for(let t=0;t<state.publicPlanPointers.length;t++){const e=state.publicPlanPointers[t];void 0===state.publicPlanDict[e]&&(state.publicPlanDict[e]=await Storage.get(e,[]));const s=state.publicPlanDict[e].find(a);if(s)return state.cachedPlans.unshift(s),s}return null}async function updatePublicPlans(t){state.cachedPlans=[];const a=T.currentTime(),e=[],s="assistant.public-plan",n=[],l=[],o=await Storage.get([s,"subscriptions"].join("."));for(let i=0;i<t.length;i++)try{const o=new URL(t[i]);o.searchParams.append("t",a.str.intSec),Log.debug(o.toString());const r=await Global.Fetcher.get(o.toString(),{}),u=JSON.parse(r),c=[s,u.name,"latest"].join(".");let g=await Storage.get(c),P="20180101";if(g&&(P=g.split(".").pop()),u.latestVersion>P){Log.debug(`Start update ${u.name} from ${P} to ${u.latestVersion}`);const t=await Global.Fetcher.get(u.updateUrl,{}),a=JSON.parse(t),o=[s,u.name,P].join("."),i=[s,u.name,u.latestVersion].join("."),r=[s,u.name,"text"].join(".");state.publicPlanDict[i]=a;const g=state.publicPlanPointers.indexOf(o);g>-1?(state.publicPlanPointers[g]=i,delete state.publicPlanDict[o],await Storage.set(i,a),await Storage.set(c,i),await Storage.remove(o),await Storage.set(r,t)):(await Storage.set(i,a),await Storage.set(c,i),await Storage.set(r,t)),e.push(i),l.push({ok:!0,subscription:u,updated:!0}),n.push(u)}else e.push(g),l.push({ok:!0,subscription:u,upToDate:!0}),n.push(u),Log.debug("Public plans up to date","name: ",u.name,"version: ",u.latestVersion)}catch(a){l.push({ok:!1,message:a.message});const r=o.find((a=>a.url===t[i]));if(r){const t=[s,r.name,r.latestVersion].join(".");e.push(t),n.push(r)}Log.error(a)}for(let t=0;t<state.publicPlanPointers.length;t++){const a=state.publicPlanPointers[t];if(-1==e.indexOf(a)){delete state.publicPlanDict[a];const t=T.deleteLastPart(a),e=[t,"latest"].join("."),s=[t,"text"].join(".");await Storage.remove([e,a,s]),Log.debug("delete",e,a,s)}}return await Storage.set([s,"pointers"].join("."),e),await Storage.set([s,"subscriptions"].join("."),n),state.publicPlanPointers=e,l}async function updateGlobalPlan(t){try{const a=JSON.parse(t);if(a.constructor!==Object)throw new Error(`The global plan must be an Object, but we've got ${a.constructor.name}`);return state.globalPlan=a,await Storage.set("assistant.global-plan",a),await Storage.set("assistant.global-plan.text",t),{ok:!0}}catch(t){return{ok:!1,message:t.message}}}async function updateCustomPlans(t){state.cachedPlans=[];try{const a=JSON.parse(t);return state.customPlans=a,await Storage.set("assistant.custom-plans",a),await Storage.set("assistant.custom-plan.text",t),{ok:!0}}catch(t){return{ok:!1,message:t.message}}}let Global=null;function init(t){Global=t,initPublicPlanPointers(),Config.load().then((t=>{t.autoUpdatePublicPlan&&Storage.get("assistant.public-plan.subscription-urls",[]).then((t=>{updatePublicPlans(t)}))}))}function restart(){state.globalPlan=null,state.cachedPlans=[],state.customPlans=null,state.publicPlanPointers=[],state.publicPlanDict={},initPublicPlanPointers()}const PlanRepository={init,restart,get,updatePublicPlans,updateCustomPlans,updateGlobalPlan};export default PlanRepository;