"use strict";import ENV from"../env.js";import T from"../lib/tool.js";import Log from"../lib/log.js";import I18N from"../lib/translation.js";import MxWcStorage from"../lib/storage.js";import SavingTool from"../saving/new-saving-tool.js";import{NativeAppClient,NativeMessage,DownloadMessage,RefreshHistoryMessage}from"../saving/native-app-message.js";const typesToCache=[],Client=new NativeAppClient(browser.runtime,typesToCache);function disconnect(e){Client.disconnect(e)}function getVersion(e){getVersionAsync().then(e,(n=>{e({ok:!1,message:n.message})}))}async function getVersionAsync(){const e=await new NativeMessage(Client,{type:"get.version"}).send();return{ok:!0,version:e.version,rubyVersion:e.rubyVersion}}function initDownloadFolder(e){getDownloadFolder((e=>{e.ok&&updateDownloadFolder(e.downloadFolder)}))}function getDownloadFolder(e){new NativeMessage(Client,{type:"get.downloadFolder"}).send().then((n=>{e({ok:!0,downloadFolder:T.sanitizePath(n.downloadFolder)})}),(n=>{e({ok:!1,message:n.message})}))}function saveTextFile(e){e.type="download.text",new DownloadMessage(Client,e).send()}function saveClipping(e,n){getVersion((o=>{let t=SavingTool.SaveClipping.MODE.COMPLETE_WHEN_MAIN_TASK_FINISHED;o.ok&&T.isVersionGteq(o.version,"0.2.0")&&(t=SavingTool.SaveClipping.MODE.COMPLETE_WHEN_ALL_TASK_FINISHED);const i=new SavingTool.SaveClipping(e,n,{mode:t});e.tasks.forEach((e=>{saveTask(e).then((({filename:n})=>{i.taskCompleted(e,{fullFilename:n})}),(n=>{i.taskFailed(e,n.message)})).catch((e=>{console.error(e)}))}))}))}function retryTask(e,n){const o=new SavingTool.RetryTask(e,n);o.started(),saveTask(e).then((({filename:e})=>{o.completed()}),(e=>{o.failed(e.message)}))}async function saveTask(e){const n=await getVersionAsync();let o=null;if("url"===e.type&&T.isVersionGteq(n.version,"0.2.4")){const n=await fetchUrlTask(e),t=await T.blob2BinaryString(n),i=Object.assign({},e,{type:"download.url",encode:"base64",content:btoa(t)});o=await new DownloadMessage(Client,i).send()}else{const n=Object.assign({},e,{type:["download",e.type].join(".")});o=await new DownloadMessage(Client,n).send()}const t=T.sanitizePath(o.filename);if(o.failed)throw new Error(o.errMsg);return"mainFileTask"==e.taskType&&updateDownloadFolder(T.sanitizePath(t).replace(e.filename,"")),{filename:t}}async function fetchUrlTask(e){return await Global.TaskFetcher.get(e)}function deleteClipping(e,n){try{e.type="clipping.op.delete",new NativeMessage(Client,e).send().then((e=>{n(e)}),(e=>{n({ok:!1,message:e.message})}))}catch(e){n({ok:!1,message:e.message})}}function refreshHistory(e,n){getVersion((o=>{let t="history.refresh";o.ok&&T.isVersionGteq(o.version,"0.2.6")&&(t="history.refresh_v2"),e.type=t,new RefreshHistoryMessage(Client,e).send().then((e=>{n(e)}),(e=>{n({ok:!1,message:e.message})}))}))}function updateDownloadFolder(e){MxWcStorage.set("downloadFolder",e)}function handleClippingResult(e){return e.url=T.toFileUrl(e.filename),e}async function getInfo(e){const n=await getVersionAsync();let o=!1,t="";return n.ok?T.isVersionGteq(n.version,ENV.minNativeAppVersion)?o=!0:t=I18N.t("g.error.handler.native-app.version").replace("$requiredVersion",ENV.minNativeAppVersion).replace("$currentVersion",n.version):t=[n.message,I18N.t("g.error.handler.native-app.install")].join("<br />"),{ready:o,message:t,version:n.version,rubyVersion:n.rubyVersion,supportFormats:["html","md"]}}let Global=null;function init(e){Global=e}const ClippingHandler_NativeApp=Object.assign({name:"NativeApp"},{init,saveClipping,saveTextFile,retryTask,handleClippingResult,getDownloadFolder,initDownloadFolder,disconnect,getInfo,getVersion,deleteClipping,refreshHistory});export default ClippingHandler_NativeApp;