"use strict";import T from"../js/lib/tool.js";import Log from"../js/lib/log.js";import I18N from"../js/lib/translation.js";import ExtApi from"../js/lib/ext-api.js";import ExtMsg from"../js/lib/ext-msg.js";import MxWcStorage from"../js/lib/storage.js";import MxWcConfig from"../js/lib/config.js";import MxWcLink from"../js/lib/link.js";import Query from"../js/lib/query.js";import Notify from"../js/lib/notify.js";import MxWcHandler from"../js/lib/handler.js";import getPikadayI18n from"../_locales/pikaday.i18n.js";const state={allClips:[],currClips:[],categories:[],tags:[]};function listenMessage(){ExtMsg.listen("history",(function(e){return new Promise(((t,i)=>{"history.reseted"===e.type?(resetHistory(),t()):i(new Error(`history.js: Unknown message: ${e.type}`))}))}))}function showHistory(){searchAction()}function showClip(e){const t=e.target.parentElement.getAttribute("data-id"),i=T.detect(state.currClips,(e=>e.clipId==t));i&&Promise.all([MxWcStorage.get("downloadFolder"),MxWcConfig.load(),ExtApi.isAllowedFileSchemeAccess()]).then((e=>{const[t,n,o]=e,a=o||n.allowFileSchemeAccess;let r,{url:l,version:c="1.0"}=i;if("2.0"===c)r=T.expandPath(i.mainPath,i.path);else{const e=i.filename?i.filename:`index.${i.format}`;r=T.replacePathFilename(i.path,e)}l||(l=r,t&&(l=T.toFileUrl([t,r].join("")))),t&&a?renderClipDetailModel_openUrlDirectly(i,l):ExtApi.findDownloadItemByPath(r).then((e=>{e?renderClipDetailModel_openUrlByDownloadItem(i,l,e):renderClipDetailModel_openUrlByCopyAndPaste(i,l)}))}))}function renderClipDetailModel_openUrlDirectly(e,t){Log.debug("directly");const i=T.queryElem(".modal"),n=T.queryElem(".modal .content"),o=renderClipDetail({urlAction:"openUrlDirectly",clip:e,url:t});T.setHtml(n,o),i.style.display="block";const a=T.queryElem(".modal .content .path-link");T.bind(a,"click",(function(e){e.preventDefault(),i.style.display="none",ExtApi.createTab(t)}))}function renderClipDetailModel_openUrlByDownloadItem(e,t,i){Log.debug("by download item");const n=T.queryElem(".modal"),o=T.queryElem(".modal .content"),a=renderClipDetail({urlAction:"openUrlByDownloadItem",clip:e,url:t,downloadItem:i});T.setHtml(o,a),n.style.display="block";const r=T.queryElem(".modal .content .path-link");T.bind(r,"click",(function(e){e.preventDefault(),n.style.display="none",ExtApi.openDownloadItem(i.id)}))}function renderClipDetailModel_openUrlByCopyAndPaste(e,t){const i=T.queryElem(".modal"),n=T.queryElem(".modal .content"),o=renderClipDetail({urlAction:"openUrlByCopyAndPaste",clip:e,url:t});T.setHtml(n,o),i.style.display="block";const a=T.queryElem(".modal .content .path");T.bind(a,"mouseover",(function(e){this.select()})),a.select()}function renderClipDetail(e){const t=T.findElem("modal-content-tpl").innerHTML;let i="";switch(e.urlAction){case"openUrlDirectly":case"openUrlByDownloadItem":i=`<a class="path-link" href="">${e.url}</a>`;break;case"openUrlByCopyAndPaste":i=`<input type="text" class='path' readonly="true" value="${e.url}" />`}return T.renderTemplate(t,{title:T.escapeHtml(e.clip.title),clipPath:i,originalUrl:e.clip.link,createdAt:e.clip.created_at,category:e.clip.category,tags:e.clip.tags.join(", "),format:e.clip.format})}function renderClips(e){state.currClips=e;const t=T.queryElem(".list"),i=T.queryElem(".no-record");if(t.style.display="none",i.style.display="none",e.length>0){const i=T.findElem("trow-tpl").innerHTML,n=[];e.forEach((function(e){n.push(T.renderTemplate(i,{clipId:e.clipId,time:renderTime(e),category:e.category,tags:e.tags.join(", "),format:e.format,title:T.escapeHtml(e.title)}))})),T.setHtml(".clippings > tbody",n.join("")),t.style.display="block"}else i.style.display="block";bindClipListener()}function renderTime(e){try{const t=T.wrapDate(e.created_at_date).str;return[t.month,t.day].join("/")}catch(e){return"-/-"}}function bindClipListener(){const e=T.queryElem(".list > table > tbody");e&&T.bindOnce(e,"click",tbodyClick,!0)}function tbodyClick(e){if("A"===e.target.tagName.toUpperCase()){const[t,i]=e.target.href.split(":");"history.delete"===t&&deleteHistory(i),e.stopPropagation(),e.preventDefault()}else showClip(e)}function deleteHistory(e){MxWcHandler.isReadyByName("NativeApp").then((t=>{t.ok?T.isVersionGteq(t.handlerInfo.version,"0.2.2")?deleteHistoryAndFile(t.config,e):Notify.error(I18N.t("error.native-app-version-too-small").replace("$VERSION",t.handlerInfo.version)):deleteHistoryOnly(e)}))}function deleteHistoryAndFile(e,t){MxWcStorage.get("downloadFolder").then((i=>{i?confirmIfNeed(I18N.t("confirm-msg.delete-history-and-file"),(()=>{const n=T.detect(state.currClips,(e=>e.clipId==t)),{version:o="1.0"}=n,a=[i,n.path].join("");let r={version:o,path:a};if("1.0"===o){const t=[i,e.rootFolder].join(""),o=a.replace("/index.json","");let l="";l=e.assetFolder.indexOf("$CLIPPING-PATH")>-1?[o,e.assetFolder.replace("$CLIPPING-PATH/","")].join("/"):e.assetFolder.indexOf("$STORAGE-PATH")>-1?[t,e.assetFolder.replace("$STORAGE-PATH/","")].join("/"):[o,""===e.assetFolder?"assets":e.assetFolder].join("/"),r.clip_id=n.clipId,r.path=a,r.asset_folder=l}ExtMsg.sendToBackground({type:"clipping.delete",body:r}).then((e=>{e.ok?(deleteHistoryOnly(e.clip_id,!0),e.message?Notify.error(I18N.t(e.message)):Notify.success(I18N.t("notice.delete-history-success"))):(console.error(e),Notify.error(I18N.t(e.message)))}))})):console.error("Error: downloadFolder not present")}))}function deleteHistoryOnly(e,t=!1){const i=state.currClips.find((t=>t.clipId===e));if(i){const n=function(){state.currClips.splice(state.currClips.indexOf(i),1),state.allClips.indexOf(i)>-1&&state.allClips.splice(state.allClips.indexOf(i),1),saveClips(state.allClips),removeTrByClipId(e)};t?n():confirmIfNeed(I18N.t("confirm-msg.delete-history"),n)}}function saveClips(e){const t=[];e.forEach((e=>{t.push(rmExtraAttribute(e))})),MxWcStorage.set("clips",t)}function rmExtraAttribute(e){return T.sliceObjByFilter(e,T.rmAttributeFilter("created_at_date","created_at_time"))}function removeTrByClipId(e){const t=`.list > table > tbody > tr[data-id="${e}"]`,i=T.queryElem(t);i&&i.parentNode.removeChild(i)}async function initSearch(){T.findElem("search").value=await cacheGet("search.keyword","");const e=getPikadayI18n(ExtApi.getLocale()),t=(new Pikaday({field:T.findElem("created-at-from"),i18n:e,toString:(e,t)=>T.wrapDate(e).beginingOfDay()}),new Pikaday({field:T.findElem("created-at-to"),i18n:e,toString:(e,t)=>T.wrapDate(e).endOfDay()}),function(e,t){return 0}),i=T.findElem("category");new Awesomplete(i,{autoFirst:!0,minChars:1,maxItems:1e4,list:state.categories,sort:t}).ul.setAttribute("tabindex","-1");const n=T.findElem("tag");new Awesomplete(n,{autoFirst:!0,minChars:1,maxItems:1e4,list:state.tags,sort:t}).ul.setAttribute("tabindex","-1"),initSearchListeners()}function initSearchListeners(){T.queryElems(".search-box").forEach((e=>{T.bind(e,"keypress",(function(e){"INPUT"===e.target.tagName.toUpperCase()&&13===e.keyCode&&searchAction(e)}))}));const e=T.findElem("search-btn");T.bindOnce(e,"click",searchAction);const t=T.queryElems("button[type=reset]");T.each(t,(e=>{T.bind(e,"click",(function(e){e.target.parentNode.reset(),searchAction()}))}))}function searchAction(e){e&&e.preventDefault();const t={__logic__:"AND"},[i,n,o]=getDateRanger();i&&(t.created_at_time=["between",n,o]);const a=T.findElem("category").value.trim();""!==a&&(t.category=["equal",a]);const r=T.findElem("tag").value.trim();""!==r&&(t.tags=["memberInclude",r]);let l={};const c=T.findElem("search").value.trim();if(cacheSet("search.keyword",c),""!==c){const e=new RegExp(c,"i");l={__logic__:"OR",title:["match",e],category:["match",e],tags:["memberMatch",e],link:["equal",c]}}const s=Query.q2Filter(t),d=Query.q2Filter(l);renderClips(Query.queryObjByFilter(state.allClips,Query.combineFilter("AND",s,d)))}function getDateRanger(){let e=T.findElem("created-at-from").value.trim(),t=T.findElem("created-at-to").value.trim();const i=e=>!isNaN(Date.parse(e));return i(e)?[!0,Date.parse(e),i(t)?Date.parse(t):Date.now()]:[!1,null,null]}function confirmIfNeed(e,t){T.findElem("confirm-mode").checked?window.confirm(e)&&t():t()}function resetHistory(){T.queryElems("form").forEach((e=>{e.reset()})),MxWcStorage.get("clips",[]).then((e=>{initState(e),searchAction()}))}function clearHistory(e){confirmIfNeed(I18N.t("confirm-msg.clear-history"),(()=>{MxWcStorage.set("clips",[]),initState([]),renderClips([]),Notify.success(I18N.t("notice.clear-history-success"))}))}function exportHistory(e){let t=T.toJson({error:I18N.t("g.hint.no-record")});state.currClips.length>0&&(t=T.toJson(state.currClips.map((e=>rmExtraAttribute(e))))),ExtMsg.sendToBackground({type:"export.history",body:{content:t}})}function initLinks(){const e=T.queryElem(".links");[{name:I18N.t("btn.reset-history"),pageName:"extPage.reset-history"}].forEach((t=>{const i=document.createElement("a");i.href=MxWcLink.get(t.pageName),i.target="_blank",i.innerText=t.name,e.appendChild(i)}))}function initActions(){const e=T.findElem("clear-history"),t=T.findElem("export-history");T.bindOnce(e,"click",clearHistory),T.bindOnce(t,"click",exportHistory)}function initModal(){const e=T.queryElem(".modal .mask");T.bindOnce(e,"click",hideModal),T.bind(document,"keydown",(function(e){27===e.keyCode&&hideModal()}));const t=T.queryElem(".modal .content");T.bind(t,"click",(function(e){e.stopPropagation()}))}function hideModal(){T.queryElem(".modal").style.display="none"}async function initSwitches(){await initCheckbox({domId:"confirm-mode",storageKey:"enableConfirmMode",defaultValue:!0}),await initCheckbox({domId:"advanced-search-mode",storageKey:"enableAdvancedSearchMode",defaultValue:!1,action:function(e){T.queryElem(".advanced-search-mode").style.display=e?"block":"none"}})}async function initCheckbox(e){const{domId:t,storageKey:i,defaultValue:n,action:o}=e,a=T.findElem(t),r=await cacheGet(i,n);a.checked=r,o&&o(a.checked),T.bind(a,"click",(async function(e){cacheSet(i,e.target.checked),o&&o(e.target.checked)}))}async function migrateLocalStorage(){const e="localstorage.migrated";if(await cacheGet(e))console.debug("migrated");else try{const t=["search.keyword","enableConfirmMode","enableAdvancedSearchMode"];for(let e=0;e<t.length;e++){const i=t[e],n=window.localStorage.getItem(i);null!==n&&("true"===n?await cacheSet(i,!0):"false"===n?await cacheSet(i,!1):await cacheSet(i,n))}await cacheSet(e,!0),console.debug("run migration")}catch(t){await cacheSet(e,!0),console.debug("run migration")}}async function cacheSet(e,t){return await MxWcStorage.set(prefixCacheKey(e),t)}async function cacheGet(e,t){return await MxWcStorage.get(prefixCacheKey(e),t)}function prefixCacheKey(e){return["history.page.cache",e].join(".")}function initState(e){e.forEach((function(e){state.categories.indexOf(e.category)<0&&state.categories.push(e.category),e.tags.forEach((function(e){state.tags.indexOf(e)<0&&state.tags.push(e)})),e.created_at_date=new Date(e.created_at),e.created_at_time=e.created_at_date.getTime()})),state.allClips=e}async function init(){await migrateLocalStorage(),listenMessage(),initState(await MxWcStorage.get("clips",[])),await initSearch(),initLinks(),initActions(),await initSwitches(),initModal(),I18N.i18nPage(),showHistory()}init();